﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


namespace QwirkleClassLibrary
{
    public class Game
    {
        private TileBag bag;
        private List<Player> players;

        public Game(List<Player> pl)
        {
            players = pl;
            bag = new TileBag(3);

            players[0].IsPlaying = true;
        }

        public int PositionPlayerPlay()
        {
            for (int i = 0; i < players.Count; i++)
            {
                if (players[i].IsPlaying == true)
                {
                    return i;
                }
            }
            return -1;
        }

        public int GetNbPlayers
        {
            get { return  players.Count; }
        }

        public List<Tile> Bag
        {
            get { return bag.TilesInBag(); }
        }

        public void ShowTileOfPlayer(int posplayer)
        {
            List<Tile> tiles = players[posplayer].Tiles;

            string r = ("Tile of " + posplayer + " : ");

            foreach(Tile tile in tiles)
            {
                r = (r + tile.NameColorTile());
            }
            Console.WriteLine(r);

        }

        public void SetNextPlayer(int old, int neew)
        {
            if (old >= 0)
            {
                players[old].IsPlaying = false;
            }
            players[neew].IsPlaying = true;
            Console.WriteLine(players[neew].GetNameTag + " you have main now !");

        }

        public void TilsBagPlayer()
        {
            for (int i = 0; i < players.Count; i++)
            {
                for (int j = 0; j < 6; j++)
                {
                    Tile tile = Bag[j];
                    players[i].AddTilePlayer(tile);
                    bag.RemoveTileInBag(tile);
                }
            }
        }

    }



}

